ParticleSystem ps;


// A class to describe a group of Particles
// An ArrayList is used to manage the list of Particles 

class ParticleSystem {

  Particle[] particles;

  int num_slots;         // total slots
  int num_particles;      // how many are used
  int head;              // the newest used slot
  int tail;              // the oldest used slot

  PVector origin;        // An origin point for where particles are born

    ParticleSystem(int num, PVector v) {
    particles = new Particle[num];
    origin = v.get();                        // Store the origin point
    num_slots = num;
    num_particles = 0;
    head = 0;
    tail = 0;
  }

  void update() 
  {
    int p = head;
    for (int i = 0; i < num_particles; i++ ) {
      particles[p].update(); 
      p--;   
      if (p < 0) p += num_slots;
    }
  }

  void render()
  {
    int p = head;
    for (int i = 0; i < num_particles-1; i++ ) {
      int next = p-1;
      if (next < 0) next += num_slots; 
      if (p != head)
      {
        ellipseMode(CENTER);
        //    stroke(255,timer);
        //    fill(100,timer);
        //    ellipse(particles[p].loc.x,particles[p].loc.y,particles[p].r,particles[p].r);
        strokeWeight(particles[p].r*2);
        //     float alp = particles[p].r/10;
        //     if (alp > 1.0) alp = 1.0;
        //     stroke(#FFFFFF,255);
        line(particles[p].loc.x,particles[p].loc.y,particles[next].loc.x,particles[next].loc.y);
      }
      p=next;
    }
  }

  void addParticle() {
    //   particles.add(new Particle(origin));
  }

  void addParticle(float x, float y) {

    // increment the head to the next slot
    if (num_particles != 0)
    {
      head++;
      // wrap as needed
      if (head == num_slots)
      {
        head = 0;
      }
    }

    particles[head] = (new Particle(new PVector(x,y)));

    // if it overrides the tail, then advance the tail
    if (num_particles == num_slots)
    {
      tail++;
      if (tail == num_slots)
      {
        tail = 0;
      }
    }
    else
    {
      num_particles++;
    }
  }

  void addParticle(Particle p) {
    //   particles.add(p);
  }

  // A method to test if the particle system still has particles
  boolean dead() {
    //   if (particles.isEmpty()) {
    //     return true;
    //   } else {
    return false;
    //   }
  }
};


// A simple Particle class

class Particle {
  PVector loc;
  PVector vel;
  PVector acc;
  float r;
  float timer;

  // Another constructor (the one we are using here)
  Particle(PVector l) {
    //   acc = new PVector(0,0.05,0);
    //   vel = new PVector(random(-1,1),random(-2,0),0);

    acc = new PVector(0,0,0);
    //    vel = new PVector(-wind_speed*time_step/meters_per_pixel,wind_speed*time_step/meters_per_pixel,0);
    vel = new PVector(0,0,0);  

    loc = l.get();
    r = start_radius;
    timer = lifetime;
  }

  // Method to update location
  void update() {
    vel.add(acc);
    loc.x += wind_speed_x*time_step/meters_per_pixel;
    loc.y += wind_speed_y*time_step/meters_per_pixel;

    loc.add(vel);
    timer -= 1.0;
    r += radius_grow * time_step;
  }

  // Method to display
  void render() {
    ellipseMode(CENTER);
    stroke(255,timer);
    fill(100,timer);
    ellipse(loc.x,loc.y,r,r);
    //   displayVector(vel,loc.x,loc.y,10);
  }

  // Is the particle still useful?
  boolean dead() {
    if (timer <= 0.0) {
      return true;
    } 
    else {
      return false;
    }
  }
}
